package com.maroontress.coverture.gcno;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.ArrayList;

/**
   LINES쥳ɤǤ

   lines: header int32:block_no line* int32:0 string:NULL
*/
public final class LinesRecord {

    /** б֥åμ̻ҤǤ */
    private int blockIndex;

    /** LINE쥳ɤΥꥹȤǤ */
    private ArrayList<LineRecord> list;

    /**
       ХȥХåեLINES쥳ɤλĤϤLINES쥳ɤ
       ޤХȥХåեΰ֤LINES쥳ɤΥϤ
       ľΰ֤ǤʤФʤޤϡХȥХåե
       ΰ֤LINES쥳ɤμΰ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException ϥ顼
    */
    public LinesRecord(final ByteBuffer bb) throws IOException {
	int length = bb.getInt();
	int next = bb.position() + 4 * length;
	blockIndex = bb.getInt();
	list = new ArrayList<LineRecord>();

	LineRecord rec;
	while (!(rec = new LineRecord(bb)).isTerminator()) {
	    list.add(rec);
	}
	bb.position(next);
    }

    /**
       ֥åμ̻Ҥޤ

       @return ֥åμ̻
    */
    public int getBlockIndex() {
	return blockIndex;
    }

    /**
       LINE쥳ɤ֤ޤ

       @return LINE쥳ɤ
    */
    public LineRecord[] getList() {
	return list.toArray(new LineRecord[0]);
    }
}
